//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vhudson-jaxb-ri-2.1-833 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.02.27 at 03:30:15 PM CET 
//


package nl.cloudfarming.client.isobus.model;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlIDREF;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.HexBinaryAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * 
 * Type: Coding data
 * 
 * Description:
 * The Product XML element describes a single product. A product can be related to a ProductGroup.
 * To determine which products belong to a specific ProductGroup, the ProductGroupIdRef values of all products
 * shall be examined for a match with a particular ProductGroupId value. Products refer both to products being
 * used in a task (i.e. crop protection chemicals) and to products being produced by a task (agricultural products).
 * The ValuePresentationIdRef and AmountDDI can be used to specify the presentation and definition of the
 * amount of the product. Examples of DDIs to use for AmountDDI as defined in ISO11783-11 are:
 *  80 Volume-based total application
 *  81 Mass-based total application
 *  82 Count-based total application
 * 
 * References XML element:
 * - ProductGroup
 * 
 * Referenced by XML element:
 * - ProductAllocation
 * - ProcessDataVariable
 *                 
 * 
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "")
@XmlRootElement(name = "PDT")
public class IsobusProduct {

    @XmlAttribute(name = "A", required = true)
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    @XmlID
    protected String productId;
    @XmlAttribute(name = "B", required = true)
    protected String productDesigNator;
    @XmlAttribute(name = "C")
    @XmlIDREF
    protected Object productGroupId;
    @XmlAttribute(name = "D")
    @XmlIDREF
    protected Object valuePresentationIdRef;
    @XmlAttribute(name = "E")
    @XmlJavaTypeAdapter(HexBinaryAdapter.class)
    protected byte[] amouNtDDI;

    /**
     * 
     * Unique identifier of product
     * Format: (PDT|PDT-)([0-9])+
     * Records generated on MICS have negative IDs
     *                         
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getProductId() {
        return productId;
    }

    /**
     * Sets the value of the productId property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setProductId(String value) {
        this.productId = value;
    }

    /**
     * 
     * Product designator/name
     *                         
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getProductDesigNator() {
        return productDesigNator;
    }

    /**
     * Sets the value of the productDesigNator property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setProductDesigNator(String value) {
        this.productDesigNator = value;
    }

    /**
     * 
     * Reference to XML element ProductGroup
     * Format: (PGP|PGP-)([0-9])+
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getProductGroupId() {
        return productGroupId;
    }

    /**
     * Sets the value of the productGroupId property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setProductGroupId(Object value) {
        this.productGroupId = value;
    }

    /**
     * 
     * Reference to XML element ValuePresentation
     * Format: (VPN|VPN-)([0-9])+
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getValuePresentationIdRef() {
        return valuePresentationIdRef;
    }

    /**
     * Sets the value of the valuePresentationIdRef property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setValuePresentationIdRef(Object value) {
        this.valuePresentationIdRef = value;
    }

    /**
     * 
     * Unique number, which defines the DDI (specified in ISO 11783-11) of the amount.
     *                         
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public byte[] getAmouNtDDI() {
        return amouNtDDI;
    }

    /**
     * Sets the value of the amouNtDDI property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setAmouNtDDI(byte[] value) {
        this.amouNtDDI = ((byte[]) value);
    }

}
